// module inifile.h
// Implements a simple (WINDOWS ini-file like) associative access
// to key-value pairs, where the keys have the form section+item
// Uses STL
// Private Copyright Dr.E.Huckert 10-2002

#ifndef INIFILE_DEFINED
#define INIFILE_DEFINED

#include <wx/string.h>
#include <wx/hashmap.h>

using namespace std;

#include "hu_trace.h"   // for trace only

WX_DECLARE_STRING_HASH_MAP(wxString,HUStringMap);

class IniFileWx
{
private:
  HUStringMap mmap;
  wxString origin_fn;
  HU_TRACE *pTrace;
  wxString makeKey(const wxString & section, const wxString & item); 
  void clean_buf(char *buf);
public:
  IniFileWx();
  ~IniFileWx();
  void setLogging(HU_TRACE *pt);
  long load(const char *filename);
  int  write(const char *filename);
  int  write(FILE *ofd);
  int  add(const wxString & section, const wxString & item, 
            const wxString & value);
  wxString get(const wxString & section, const wxString & item);
  int  replace(const wxString & section, const wxString & item, 
               const wxString & value);
  wxString get(wxString item);
  int getInt(const wxString & section, const wxString & item);
  int  erase(const wxString & section, const wxString & item);
  long getSize()
  {
    return this->mmap.size();
  };
};

#endif


